﻿/* *******************************************************************
 * Function of RSListMenuConf.xul onload.
 *
 * *******************************************************************
 */
 function RSF_listMenuConfInit(event)
 {
  try{
      var m_type = window.arguments[1];
     
      if('RSList'==m_type)
      {
              document.getElementById('1').removeAttribute('hidden');
              document.getElementById('2').setAttribute('hidden','true');
              netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
              
              // 数据源树
              var m_tree = document.getElementById('3');
              var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                                   getService(Components.interfaces.nsIRDFService);
              var ds = window.arguments[0];
                  
              // If do the following code, RegisterDataSource ,there will be an error.
              // And that may be the rdfService does not know how to refresh the datasource
              // because that datasource is coming from a DBAcess component.
              //        rdfService.RegisterDataSource(ds,true);
              //        var inmemds = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"]
              //                .createInstance(Components.interfaces.nsIRDFDataSource);             
              //        inmemds = ds;             
                                    
              var m_pre = 'http://realso.cn/rdf#IsRoot';
              var m_obj = 'true';
              var m_resPre = rdfService.GetResource(m_pre);
              var m_resObj = rdfService.GetLiteral(m_obj);
              var subjects = ds.GetSources( m_resPre , m_resObj , true);    
                   
              while(subjects.hasMoreElements( ))
              {  
                var m_rdfResource = subjects.getNext();
                    
                m_rdfResource.QueryInterface(Components.interfaces.nsIRDFResource);
                m_tree.ref  = m_rdfResource.Value;
              }
               
              var tds = m_tree.database.GetDataSources();
              while (tds.hasMoreElements())
              {
                 m_tree.database.RemoveDataSource(tds.getNext());
              }
              m_tree.database.AddDataSource(ds);
              m_tree.builder.rebuild();
      }
        else
        {
              if('menulist'==m_type)
              {
                    document.getElementById('2').removeAttribute('hidden');
                    document.getElementById('1').setAttribute('hidden','true');
                    var m_dsPath   = window.arguments[2];
                    
                    var m_tempPath = m_dsPath.value.slice(1,-1);
                    var m_textbox  = document.getElementById('20');
                    
//                    var m_tempPathArr = m_tempPath.split(/\\n\B/)
//                    
//                    for(var i=0;i<m_tempPathArr.length;i++)
//                    {
//                        if(''!=m_tempPathArr[i])
//                        m_textbox.value = m_textbox.value+m_tempPathArr[i]+'\n';     
//                    }
                    m_textbox.value = unescape(m_tempPath);
              }
        }
  
  
  }catch(e){
     alert('BindConfig3.js RSF_listMenuConfInit() '+e);
     throw e;
  } 
 }
 
/* ***********************************************************************************
 * Selecting path of database from tree.It is the select event of tree.
 * When selecting a database path, giving the field menulist a ref attribute and rebu-
 * ilding the menulist. 
 * ***********************************************************************************
 */
 function RSF_treeSelect(event)
 {
    try{
        var m_selInd = event.target.view.selection.currentIndex;
        var m_l = event.target.view.getLevel(m_selInd);
        var m_dsPath = RSF_getPath(event.target, m_selInd);
        var m_ds = RSF_getDatasource(event.target, m_selInd);
        event.target.setAttribute('ds_path',m_dsPath);
    }catch(e){
       alert('BindConfig3.js RSF_treeSelect() '+e);
       throw e; 
    }
 
 }
 
  /* *********************************************************************
   * Function for getting datasource path, datasource is a field path 
   * joined with string '->'.
   * *********************************************************************
   */
    function RSF_getPath(m_tree, m_selIndex)
    {
      try{
          var m_path='';
          var m_parIndex = m_tree.view.getParentIndex(m_selIndex);
          var m_tempPath;
          
          while(-1!=m_parIndex)
          {
            m_tempPath = m_tree.view.getCellText(m_parIndex ,m_tree.columns[1]);
            m_parIndex = m_tree.view.getParentIndex(m_parIndex); 
            m_path = m_tempPath +'->'+ m_path;
          }
          
          m_path = m_path.slice(0,-2);
          return m_path;
      }catch(e){
         alert('BindConfig3.js RSF_getPath() '+e);
         throw e;
      }
    }
    
  /* ********************************************************************* 
   * Function for getting table URI from tree value.
   * The returned value is often used at 'ref' attribute setting
   * *********************************************************************
   */
    function RSF_getDatasource(m_tree, m_selIndex)
    {
     try{
         var m_ds = m_tree.view.getCellValue(m_selIndex ,m_tree.columns[0]);
         
         return m_ds;
     }catch(e){
        alert('BindConfig3.js RSF_getDatasource() '+e);
        throw e;
     }
    }
    
  /* *********************************************************************
   * Function of RList config OK button
   *
   * *********************************************************************
   */
   function RSF_RListOK(event)
   {
    try{
        var m_dsPath = window.arguments[2];
        m_dsPath.value ='(' + document.getElementById('3').getAttribute('ds_path') + ')';
        window.close();
    }catch(e){
       alert('BindConfig3.js RSF_RListOK() '+e);
       throw e;
    }
   }
   
  /* *********************************************************************
   * Function of RList config Cancel button
   *
   * *********************************************************************
   */
   function RSF_RListCancel(event)
   {
    try{
        window.close();
    }catch(e){
       alert('BindConfig3.js RSF_RListCancel() '+e);
       throw e;
    }
   }
   
  /* *********************************************************************
   * Function of RList config Apply button
   * *********************************************************************
   */
   function RSF_RListApply(event)
   {
    try{
        var m_dsPath = window.arguments[2];
        m_dsPath.value ='(' + document.getElementById('3').getAttribute('ds_path') + ')';
    }catch(e){
       alert('BindConfig3.js RSF_RListApply() '+e);
       throw e;
    }
   }
     
  /* *********************************************************************
   * Function of menulist config OK button
   *
   * *********************************************************************
   */
   function RSF_menulistOK(event)
   {
    try{
        RSF_menulistApply(event);
        window.close();
    }catch(e){
       alert('BindConfig3.js RSF_menulistOK() '+e);
       throw e;
    }
   }
   
  /* *********************************************************************
   * Function of menulist config Cancel button
   *
   * *********************************************************************
   */
   function RSF_menulistCancel(event)
   {
    try{
        window.close();
    }catch(e){
       alert('BindConfig3.js RSF_menulistCancel() '+e);
       throw e;
    }  
   }
   
  /* *********************************************************************
   * Function of menulist config Apply button
   * *********************************************************************
   */
   function RSF_menulistApply(event)
   {
    try{
//        var m_dsPath   = window.arguments[2];
//        var m_tempPath = '';
//        var m_textbox  = document.getElementById('20');
//        var m_regexp   = /\n+/;
//        var m_items    = m_textbox.value.split(m_regexp);
//        
//        for(var i=0;i<m_items.length;i++)
//        {
//              if(''!=m_items[i])
//              {
//                 m_tempPath = m_tempPath + '\\n' + m_items[i];                   
//              }
//        }
//        
//        m_tempPath = m_tempPath.slice(2);
//        m_tempPath = '(' + m_tempPath + ')';
//        m_dsPath.value = m_tempPath;
          
          var m_dsPath   = window.arguments[2];
          var m_tempPath = '';
          var m_textbox  = document.getElementById('20');
          
          m_dsPath.setAttribute('value','('+escape(m_textbox.value)+')');
          m_dsPath.value = '('+escape(m_textbox.value)+')';
           
    }catch(e){
       alert('BindConfig3.js RSF_menulistApply() '+e);
       throw e;
    }
   }
