﻿// 全局变量
// 2006-12-13 added,for storing the current cooordinate of the mouse when it down
var gScreenXMouse;
var gScreenYMouse;

//RSVisualGlobalSpace Defined on Aug 22, using as a namespace
var RSVisualGlobalSpace = new Object;
const RSWVisualNS = RSVisualGlobalSpace;

RSVisualGlobalSpace.VisualCurrentState = 'default';
RSVisualGlobalSpace.atomElementEdit = new Array();
//屏幕长宽
const g_screenLength = 1024;
const g_screenWidth  = 768;
//属性栏窗口
var g_attriWindow = null;
// Message
var g_messageList= new Array(); 
var g_message    = new Array();  
/* *************************************************************************
 * 工具箱，工作区，工程浏览窗口的id和style
 * *************************************************************************
*/
const g_tool_boxWindo_box_id = 'ToolkitTreebox';
const g_tool_boxWindow_id = 'ToolkitTree';
const g_tool_boxWindow_style = 'background-color: #C0C0C0;';

const g_work_areaWindow_id = 'RSWEditTab';
const g_work_areaWindow_style = "";
const g_work_areaWindow_tabpanel_id = 'RSWEditTabtabpanels';

const g_workspace_navigator_id = 'workspace_navigator';
const g_workspace_navigator_style = "";
//**************************************************************************

/***************************************************************************
 * 定义哪些element是container
 * NOTE:
 * vbox一定不能从g_container中去除，否则会出错。因为原始文档
 * 中的window是用vbox取代的，如果window用其它element取代也是
 * 一样的道理。
 ***************************************************************************
*/
var g_container = new Array( 'box' ,'vbox', 'hbox' , 'groupbox' ,'radiogroup', 'stack' ,'bbox','toolbox' , 'window','scrollbox','rsdeck');
 
var g_absolute_pos_container = new Array('stack');
//**************************************************************************

/***************************************************************************
 * Define some special container, because we using them(tree,tabbox,listbox,
 * richlistbox,etc.) as atom element.
 ***************************************************************************
*/
RSVisualGlobalSpace.g_atomElement = new Array( );
RSVisualGlobalSpace.g_atomElementFather = new Array('tree', 'tabbox', 'listbox','richlistbox','rsmenulist','grid');
RSVisualGlobalSpace.atomElementEdit['tree']        = true;
RSVisualGlobalSpace.atomElementEdit['tabbox']      = true;
RSVisualGlobalSpace.atomElementEdit['listbox']     = true;
RSVisualGlobalSpace.atomElementEdit['richlistbox'] = true;
RSVisualGlobalSpace.atomElementEdit['rsmenulist']  = true;
RSVisualGlobalSpace.atomElementEdit['grid']        = true; 

RSVisualGlobalSpace.g_atomElement['tree']        = new Array('treecols', 'treecol' , 'treechildren' , 'treeitem' , 'treerow' , 'treecell');
RSVisualGlobalSpace.g_atomElement['listbox']     = new Array('listhead' , 'listheader' , 'listitem' , 'listcols' , 'listcol' , 'listcell' ); 
RSVisualGlobalSpace.g_atomElement['tabbox']      = new Array('tabs' , 'tab' , 'tabpanels', 'tabpanel');
RSVisualGlobalSpace.g_atomElement['richlistbox'] = new Array('richlistitem');
RSVisualGlobalSpace.g_atomElement['rsmenulist']    = new Array('menupopup','menuitem');
RSVisualGlobalSpace.g_atomElement['grid']        = new Array('rows','row','columns','column');
 
RSVisualGlobalSpace.g_atomElementChild = new Array('treecols', 'treecol' , 'treechildren' , 'treeitem' , 'treerow' , 'treecell',
                                                   'listhead' , 'listheader' , 'listitem' , 'listcols' , 'listcol' , 'listcell',
                                                   'tabs' , 'tab' , 'tabpanels', 'tabpanel','richlistitem','radio' , 'menupopup',
                                                   'menuitem','rows','row','columns','column','toolbar','toolbarbutton','menubar',
                                                   'menu','caption');

// Defining the father of all the g_atomElementChild.
// eg. treecols' father could be a tree
//     treecol'  father could be a treecols

RSVisualGlobalSpace.g_atomElementChild['toolbar'] = ['toolbox']; 
RSVisualGlobalSpace.g_atomElementChild['toolbarbutton'] = ['toolbar']; 
RSVisualGlobalSpace.g_atomElementChild['menubar'] = ['toolbox']; 
RSVisualGlobalSpace.g_atomElementChild['menu'] = ['menubar','menupopup']; 

RSVisualGlobalSpace.g_atomElementChild['treecols'] = ['tree']; 
RSVisualGlobalSpace.g_atomElementChild['treecol']  = ['treecols'];
RSVisualGlobalSpace.g_atomElementChild['treechildren'] = ['tree','treeitem'];
RSVisualGlobalSpace.g_atomElementChild['treeitem'] = ['treechildren'];
RSVisualGlobalSpace.g_atomElementChild['treerow']  = ['treeitem'];
RSVisualGlobalSpace.g_atomElementChild['treecell'] = ['treerow'];

RSVisualGlobalSpace.g_atomElementChild['listhead']   = ['listbox'];
RSVisualGlobalSpace.g_atomElementChild['listheader'] = ['listhead'];
RSVisualGlobalSpace.g_atomElementChild['listitem'] = ['listbox'];
RSVisualGlobalSpace.g_atomElementChild['listcols'] = ['listbox'];
RSVisualGlobalSpace.g_atomElementChild['listcol']  = ['listcols'];
RSVisualGlobalSpace.g_atomElementChild['listcell'] = ['listitem'];

RSVisualGlobalSpace.g_atomElementChild['tabs'] = ['tabbox'];
RSVisualGlobalSpace.g_atomElementChild['tab']  = ['tabs'];
RSVisualGlobalSpace.g_atomElementChild['tabpanels'] = ['tabbox'];
RSVisualGlobalSpace.g_atomElementChild['tabpanel']  = ['tabpanels'];

RSVisualGlobalSpace.g_atomElementChild['richlistitem'] = ['richlistbox'];

//Tip: It's special, radio element can only be as child of radiogroup but radiogroup element is a common container.
RSVisualGlobalSpace.g_atomElementChild['radio']   = ['radiogroup'];

RSVisualGlobalSpace.g_atomElementChild['caption'] = ['groupbox'];
///////////////////
RSVisualGlobalSpace.g_atomElementChild['menupopup'] = ['rsmenulist','menu'];
RSVisualGlobalSpace.g_atomElementChild['menuitem']  = ['menupopup'];

RSVisualGlobalSpace.g_atomElementChild['rows']  = ['grid'];
RSVisualGlobalSpace.g_atomElementChild['row']   = ['rows'];
RSVisualGlobalSpace.g_atomElementChild['columns']  = ['grid'];
RSVisualGlobalSpace.g_atomElementChild['column']   = ['columns'];

/* ////////////////////////////////////////////////////////////////////////////
 * Defined some g_atomElementChildContainer, which is a g_atomElementChild but 
 * could be active as a normal container.You can put any element inside them.
 */////////////////////////////////////////////////////////////////////////////
RSVisualGlobalSpace.g_atomElementChildContainer = new Array('tabpanel','listitem','richlistitem','row');
RSVisualGlobalSpace.g_atomElementChildContainer['tabpanel'] = 'tabpanel';
RSVisualGlobalSpace.g_atomElementChildContainer['listitem'] = 'listitem';
RSVisualGlobalSpace.g_atomElementChildContainer['richlistitem'] = 'richlistitem';
RSVisualGlobalSpace.g_atomElementChildContainer['row'] = 'row';
//************************************************************************************************

/* 确定哪些element在选中时用border来改变边框
 *
 */
var g_border_element = new Array('button','textbox','checkbox');
//************************************************************************************************

/* ***********************************************************************************************
 * Single document message functions.
 * It is the xul document message functions.
 * This function is called by the RS_edge xbl.
 * ***********************************************************************************************
 */
 function f_push_message(obj_this)
 {
     try{
         g_messageList.push(obj_this);
         /*
                   var m_DocId = RSWf_getCurrentXULDoc().ID;
     
                   var m_nodeList = document.getElementById('stack'+m_DocId).getElementsByTagName('RS_edge');
                   
                   for(var j=0;j<m_nodeList.length;j++)
                     {  
                       try{
                       if((m_nodeList[j]!=obj_this[0]) && (m_nodeList[j].RS_edge_getAttribute('id')!='m_edge'))
                       {  
                         m_nodeList[j].RS_edge_setAttribute('edge_state',obj_this[0].RS_edge_getAttribute('edge_state'));
                         m_nodeList[j].RS_edge_setAttribute('pre_mouse_y',obj_this[0].RS_edge_getAttribute('pre_mouse_y'));  
                         m_nodeList[j].RS_edge_setAttribute('pre_mouse_x',obj_this[0].RS_edge_getAttribute('pre_mouse_x'));                         
                         m_nodeList[j].RS_edge_setAttribute('can_adjust_left',obj_this[0].RS_edge_getAttribute('can_adjust_left'));
                         m_nodeList[j].RS_edge_setAttribute('can_adjust_top',obj_this[0].RS_edge_getAttribute('can_adjust_top'));
                         m_nodeList[j].RS_edge_setAttribute('can_adjust_width',obj_this[0].RS_edge_getAttribute('can_adjust_width'));
                         m_nodeList[j].RS_edge_setAttribute('can_adjust_height',obj_this[0].RS_edge_getAttribute('can_adjust_height'));
                        
                       }
                        }catch(e)
                               {
                                alert(e);
                               }
                            
                     }*/
         return 0;
     }catch(e){
        alert('Exception from Edit.js f_push_message() '+e);
        throw e;
     }
 }

/* **********************************************************************************************
 * This function is called by the mouseup message function of the stack of vbox of window 
 * **********************************************************************************************
 */
 function f_pop_message(inner_event)
 {
     try{ 
          
         if(g_messageList.length>0)
         {    
              for(var i=0;i<g_messageList.length;i++)
              {  
                if(g_messageList[i][0].parentNode!=null)
                {
                    g_messageList[i][0].edge_mouseup(g_messageList[i][1]);  
                  
                }
                
                g_messageList.splice(i,1);
                i--;
              }
              
              for(i=0;i<g_message.length;i++)
              {  
                g_message.splice(i,1);
                i--;
              }
          }
                
          for(var i=0;i<g_message.length;i++)
          {  
              f_DestroyMessage(g_message[i],inner_event);
              delete g_message[i];
              g_message.splice(i,1);
              i--;
          }
          return 0; 
     }catch(e){
        alert('Exception from Edit.js f_pop_message() '+e);
        throw e;
     }
 }

/* **********************************************************************************************
 * This function is called by the mousemove message of the stack of vbox of window 
 * **********************************************************************************************
 */
 function f_doc_mousemove(event)
 { 
     try{ 
         if(g_messageList.length>0)
          {
              for(var i=0;i<g_messageList.length;i++)
              {              
                if(g_messageList[i][0].parentNode!=null)
                    g_messageList[i][0].edge_move(g_messageList[i][1],event,1,1);
                    
                f_repaint(event);
              }
          } 
          else
          {
              if(g_message.length>0)
              { 
                  for(var j=0;j<g_message.length;j++)
                  {   //alert('move');   
                      var m_inner = f_ConMessageWithEvent(event,g_mousedownMessageflag);
                       
                      f_HandleMessage(g_message[j],m_inner);
                  }
              }
              else
              {
                  f_pick_up(event);
              }
          }
          event.stopPropagation();
          event.preventDefault();
          
          return 0;
      }catch(e){
           alert('Exception from Edit.js f_doc_mousemove() '+e);
           throw e;
           return -1;
      }
 }
 
/*
 * When the stack of window vbox happens mouseup message,this function is triggered.
 */
 function f_doc_mouseup(event)
 { 
  try{
      g_mousedownMessageflag = false;
      f_pop_message(f_ConMessageWithEvent(event,g_mousedownMessageflag));
      
      event.stopPropagation();
      return 0;
  }catch(e){
      alert('Exception from Edit.js f_doc_mouseup() '+e);
  }
 }
    
/*
 * When the stack of window vbox happens mousedown message,this function is triggered.
 */  
 function f_doc_mousedown(event)
 {  
     g_mousedownMessageflag = true;
 }
    
/*
 * What will happen,when Del key was pressed.    
 */
 function RSWf_key_(event)
 { 
   try{
       var m_Doc = RSWf_getCurrentXULDoc();
       var m_DocId = m_Doc.ID; 
       
       switch(event.keyCode)    
       {
        // VK_DELETE 's ASII encode is 46
        case 46:  
        {   
              for(var i=0;i<g_selected_array[m_DocId].length;i++)
              {
                 var m_seld = g_selected_array[m_DocId][i].m_element_obj;
                  
                 // The agency document itself can not be deleted.
                 if(m_seld==m_Doc.DOMNode)
                 {
                      continue;
                 }
                 var m_unique_edgeID = m_DocId+g_partion; 
                 
                 var m_p = document.getElementById('stack'+m_DocId).removeChild(document.getElementById(m_unique_edgeID+m_seld.id));
                  
                 // If the removed element is a tab, there will something wrong happen with the selected tab.
                 // So, there is some need to reselect the tab.
                 var temp = null;
                 if('tab'==m_seld.tagName)
                 {
                      temp = m_seld.parentNode.parentNode;
                 }
                 m_Doc.RSXULRemove(m_seld);
                 if(null!=temp)
                 {
                    temp.selectedIndex = 0;
                 }
                 if(null!=g_attriWindow)
                 {
                    g_attriWindow.f_delAttribute(m_seld);
                 }
                 g_selected_array[m_DocId].splice(i,1);
                 i--;
              }
              f_autoSendMousedownUp(m_Doc.DOMNode,event);
        }
        break;
       }
       
       switch(event.charCode)
       {
        // W
        case 119:
        {   
            if(0!=g_selected_array[m_DocId].length)
                 f_autoSendMousedownUp(g_selected_array[m_DocId][g_selected_array[m_DocId].length-1].m_element_obj.parentNode,event);
        }
        break;
        // A
        case 97:
        { 
            if(0!=g_selected_array[m_DocId].length)
                 f_autoSendMousedownUp(g_selected_array[m_DocId][g_selected_array[m_DocId].length-1].m_element_obj.previousSibling,event);
        }
        break;
        // D
        case 100:
        { 
            if(0!=g_selected_array[m_DocId].length)
            {    
                  var m_temp = g_selected_array[m_DocId][g_selected_array[m_DocId].length-1].m_element_obj;
                  if(m_temp!=m_Doc.DOMNode)
                      f_autoSendMousedownUp(m_temp.nextSibling,event);
            }
                   
        }
        break;
        // S
        case 115:
        { 
            if(0!=g_selected_array[m_DocId].length)
                 f_autoSendMousedownUp(g_selected_array[m_DocId][g_selected_array[m_DocId].length-1].m_element_obj.firstChild,event);
        } 
        break;
      }
    }catch(e){
         alert('Exception from Edit,js RSWf_key_()'+e);
    }
     return 0;
  }   
 
 /*
  * The message function for mousedown message of the xul document.
  */
  function f_attach(event)
  {   
      gScreenXMouse = event.screenX;
      gScreenYMouse = event.screenY;
      fClipboardCheck();
      
      var m_DocId = RSWf_getCurrentXULDoc().ID;
      // Whenever ,store message first,then do other thing.
      //////////////////////////////////////////////////////////////////////
      g_mousedownMessageflag = true;
      try{  
          var sStackIDofWorkarea = 'stack'+m_DocId;
          
          // 如果不是在当前工作区上按下左键
          if(event.target.id!=sStackIDofWorkarea)
          {
              if(document==event.target.ownerDocument)
              {
                  // 原本是用来判断当前XUL中的iframe的,但似乎没有起作用
                  if(!(event.target.ownerDocument instanceof  Components.interfaces.nsIDOMHTMLDocument))
                  { 
                      var m_flag = true;
                      var m_atomEleFl = RSVisualGlobalSpace.g_atomElementFather;
                      for(var j=0;j<m_atomEleFl.length;j++)
                      {
                          if((null!=f_getTreeTabbox(event.target,m_atomEleFl[j]))&&
                             (RSVisualGlobalSpace.atomElementEdit[m_atomEleFl[j]]))
                          {
                               m_flag = false;
                               break;
                          }
                      }
                                    
                      // If the element is a normal xul element, directly select
                      if(m_flag)
                      {  
                          g_message.push(f_ConMessageWithEvent(event,g_mousedownMessageflag,"stackMouseDown")); 
                          //g_attriWindow.f_showAttribute(event.target);
                          f_select(event);
                      } 
                      else
                      {
                          if(RSVisualGlobalSpace.VisualCurrentState=='default') 
                          {
                              // At the default state , you can not select atomElement Child.
                              var m_atom = RSVisualGlobalSpace.g_atomElementFather;
                                                 
                              for(var i=0;i<m_atom.length;i++)
                              {
                                  if((f_getTreeTabbox(event.target,m_atom[i])!=null)&&
                                     (RSVisualGlobalSpace.atomElementEdit[m_atom[i]]))
                                  {
                                      RSW_autoSendMessage('mousedown',m_atom[i],event);  
                                  }
                              }
                          }
                          else
                          {
                              g_message.push(f_ConMessageWithEvent(event,g_mousedownMessageflag,"stackMouseDown")); 
                              //g_attriWindow.f_showAttribute(event.target);
                              var m_DocId = RSWf_getCurrentXULDoc().ID;
                              f_select(event);
                          } // if(RSVisualGlobalSpace.VisualCurrentState=='default') 
                      } //if((f_getTreeTabbox(event.target,'tree')==null)&&(f_getTreeTabbox(event.target,'tabbox')==null)&&
                                       
                  } // if(!(event.target.ownerDocument instanceof  Components.interfaces.nsIDOMHTMLDocument))
                  else
                  {
                      
                  }
                         
                  window.setTimeout(RSFLoseFocus,20,m_DocId);
              }
              else
              {
                  // 如果该event是内嵌iframe 或 brower发出的什么也不做
              }
          }
          else
          {
              // 在工作区上按下左键什么也不做
          }
       }catch(e){
          alert('Exception from Edit.js f_attch() '+e);
       }
       /////////////////////////////////////////////////////////////////////
    }
    
  /* ************************************************************************
   * Not moving focus in a focused element function.
   * So, the following function is called after 20ms after the other element
   * lose focus.
   * ************************************************************************
   */
    function RSFLoseFocus(m_DocId)
    {
        document.getElementById('stack'+m_DocId).focus();
    }
    
    function f_iframeattach(event)
    {
     try{
          var m_event = f_ConMessageWithEvent(event);
          m_event.target = this;
         
          f_attach(m_event);
          event.preventDefault();
          event.stopPropagation();
     }catch(e){
        alert(e);
     }
    }
    
    function f_autoSendMousedownUp(m_obj,inner_event)
    {
      try{
          if(null!=m_obj)
          {
            //After all the selected object are deleted,current selected will be set to window of itself
            var ea = document.createEvent("MouseEvent"); 
            ea.initMouseEvent("mousedown", true, true, window,
                               0,inner_event.screenX, inner_event.screenY, inner_event.clientX , inner_event.clientY, inner_event.ctrlKey, 
                               inner_event.altKey, inner_event.shiftKey,
                               inner_event.metKey, inner_event.button, null);          
            m_obj.dispatchEvent(ea);  
            
            var ea1 = document.createEvent("MouseEvent"); 
            ea1.initMouseEvent("mouseup", true, true, window,
                               0,inner_event.screenX, inner_event.screenY, inner_event.clientX , inner_event.clientY, inner_event.ctrlKey, 
                               inner_event.altKey, inner_event.shiftKey,
                               inner_event.metKey, inner_event.button, null);    
            m_obj.dispatchEvent(ea1);
          }
       }catch(e){
          alert('Edit.js f_autoSendMousedownUp()'+ e);
       }
    }
    
/*____________________________________________________________________________________________
 */
 
/////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////

function RSWf_workspace_mousedraggesture(event)
{
 try{
    //g_message.push(f_ConMessageWithEvent(event,g_mousedownMessageflag)); 
 }catch(e){
    alert('Exception from Edit.js f_doc_mousedraggesture() '+e);
 }
}
   
// 设置元素在中间文档中的默认属性
// 还有的属性是元素在原始文档中的默认属性,如容器的初始大小等
function f_setelement_default(m_obj)
{ 
  switch(m_obj.tagName)
  {
   case 'button':
         m_obj.setAttribute('style', 'margin:40px 20px;');
         break;
   case 'textbox':
        // m_obj.disabled=true;
        // alert('dis');
        // m_obj.setAttribute('style',"-moz-appearance: none ;color: -moz-DialogText; background-color: white;-moz-outline:dashed;-moz-user-focus:ignore;padding: 20px 20px 30px 400px;margin: 20px 40px; cursor:move;" );
        // alert('hello');
         break;
  }
}

/* 查找某个element在选中时是否应该用border来更改边框
 * 是，则返回非-1；
 * 否，则返回 -1。
*/
function f_in_border_ele(m_obj_tag)
{
 for(var i=0;i<g_border_element.length;i++)
 {
  if(g_border_element[i]==m_obj_tag)
    return i; 
 }
 return -1;
}

/* 表示是否处在移动已经存在的element状态 
 * -1为：不处在移动状态
 * 1 为：移动绝对定位的容器（stack）内一个element
 * 0 为：移动相对定位的容器内一个element
 */
var g_move_element=-1;                 
var g_move_element_mouseX;             /* The mouse position before move some element*/
var g_move_element_mouseY;             /* */

var g_current_insert_obj=null;     // 当前在哪个element前插入

// 用于判断鼠标所在的容器及其外层容器是否有m_id的容器
function f_workspace(m_obj,m_id)
{
  while(m_obj!=null)
  {
     if(m_obj.id==m_id)
     {
        return true;
     }
     else
     {
        m_obj=m_obj.parentNode;
     }    
  }
  return false;
}

/* Judge whether a element is a g_atomElement
 * If return value is 0, means that element is a tree
 * return value is 1, means that element is a listbox
 * return value is 2, means that element is a tabbox
 * return value is 3, means that element is a richlistbox
 * return value is 4, means that element is a radiogroup
 * If the tested element is not a g_atomElement, return -1;
*/
function f_judgeAtomElement(m_obj)
{
  try{
      if(RSVisualGlobalSpace.g_atomElement[m_obj.tagName]!=null)
      {
          return m_obj.tagName;
      }
      else
      {
          return -1;
      } 
  }catch(e){
     alert('Exception from Edit.js f_judgeAtomElement()'+e);
     throw e;
  }
}

function f_judgeFiliation(m_father,m_son)
{
 try{
     var m_fathers = RSVisualGlobalSpace.g_atomElementChild[m_son];
     for(var i=0;i<m_fathers.length;i++)
     {
        if(m_father == m_fathers[i])
           return true;
     }
     return false;
 
 }catch(e){
    alert('Exception from Edit.js f_judgeFiliation()'+e);
    throw e;
 }
}

/* Test whether a element is a RSVisualGlobalSpace.g_atomElementChild
 *
 */
 function f_judgeAtomElementChild(m_obj)
 {
   try{  
       if(RSVisualGlobalSpace.g_atomElementChild[m_obj.tagName]==null)   
          return false;
       else
          return true;
          
   }catch(e){
      alert('Exception from Edit.js f_judgeAtomElementChild()'+e);
      throw e;
   }
 }

/* Test whether a element is a RSVisualGlobalSpace.g_atomElementChildContainer
 *
 */
function f_judgeAtomElementChildContainer(m_obj)
{ 
  try{ 
      if(RSVisualGlobalSpace.g_atomElementChildContainer[m_obj.tagName]!=null)
         return true;
      else
         return false;
  
  }catch(e){
     alert('Exception from Edit.js f_judgeAtomElementChildContainer() '+e);
     throw e;
  }
}

/////////////////////////////////////////////


/* 判断一个element是不是容器
 * 返回  1，容器是绝对定位的
 * 返回  0，容器是相对定位的
 * 返回 -1，不是容器
 * g_atomElement is not container
*/
function f_judgeContainer(m_obj)
{
 try{
     var i=0;
     while(i < g_container.length)
     {
         if(m_obj.tagName==g_container[i])
         {
            var j=0;
            while(j < g_absolute_pos_container.length)
            {
                if(m_obj.tagName==g_absolute_pos_container[j])
                   return 1;
                j++;
            }
            return 0;
         }
         i++;     
      }
  }catch(e){
      alert('Exception from Edit.js f_judgeContainer() '+e);
  }
      return -1;
}

/* 返回一个容器中子element与坐标x,y“最近”的element,容器为空则返回NULL
 * 鼠标当前的坐标与容器内的element的左上角坐标相比较，
*/
/*
function f_near_element(m_container,x,y)
{ 
  var m_near_element=null;
  var m_prenear_distance=g_screenLength;
  var m_near_distance=g_screenLength;
  var i=0;
  
  while(i<m_container.childNodes.length)
  { 
   m_near_distance=Math.sqrt((m_container.childNodes[i].boxObject.x-x)*(m_container.childNodes[i].boxObject.x-x)+
                   (m_container.childNodes[i].boxObject.y-y)*(m_container.childNodes[i].boxObject.y-y));

   if(m_near_distance < m_prenear_distance)
      {
        m_near_element=m_container.childNodes[i];
      }
   m_prenear_distance=m_near_distance;
   i++;
  
  }
 
  return m_near_element;
}
*/
/* 返回一个容器中子element与坐标x,y“最近”的element,容器为空则返回NULL
 * 鼠标当前的坐标与容器内的element的中间点坐标相比较，
 */
 function f_near_element(m_container,x,y)
 { 
   var m_near_element=null;
   var m_prenear_distance=g_screenLength;
   var m_near_distance=g_screenLength;
   var i=0;
  
   while(i<m_container.childNodes.length)
   { 
      m_near_distance=Math.sqrt(((2*m_container.childNodes[i].boxObject.x+m_container.childNodes[i].boxObject.width)/2-x)
                                *((2*m_container.childNodes[i].boxObject.x+m_container.childNodes[i].boxObject.width)/2-x)+
                                ((2*m_container.childNodes[i].boxObject.y+m_container.childNodes[i].boxObject.height)/2-y)
                                *((2*m_container.childNodes[i].boxObject.y+m_container.childNodes[i].boxObject.height)/2-y));

      if(m_near_distance < m_prenear_distance)
      {
         m_near_element=m_container.childNodes[i];
      }
      m_prenear_distance=m_near_distance;
      i++;
   }
 
   return m_near_element;
 }

/* 比较x，y坐标与m_obj的左上角坐标，和右下角坐标的远近
 * 如果离左上角坐标近，则返回本节点， 如果离右下脚坐标
 * 近则返回本节点的下一个节点（无论是否为空）;
 * 本函数与上一个函数在一起使用。
 */
function f_compare_pos(m_obj,x,y)
{
 var m_leftUp     = Math.sqrt((m_obj.boxObject.x-x)*(m_obj.boxObject.x-x)+(m_obj.boxObject.y-y)*(m_obj.boxObject.y-y));
 var m_leftBottom = Math.sqrt((m_obj.boxObject.x-x)*(m_obj.boxObject.x-x)+(m_obj.boxObject.y+m_obj.boxObject.height-y)*(m_obj.boxObject.y+m_obj.boxObject.height-y));
 var m_rightBottom= Math.sqrt((m_obj.boxObject.x+m_obj.boxObject.width-x)*(m_obj.boxObject.x+m_obj.boxObject.width-x)+(m_obj.boxObject.y+m_obj.boxObject.height-y)*(m_obj.boxObject.y+m_obj.boxObject.height-y));
 var m_rightUp    = Math.sqrt((m_obj.boxObject.x+m_obj.boxObject.width-x)*(m_obj.boxObject.x+m_obj.boxObject.width-x)+(m_obj.boxObject.y-y)*(m_obj.boxObject.y-y));
 
 var m_left;
 var m_right;
 
 if((m_leftUp-m_leftBottom)<=0)
    m_left=m_leftUp;
 else
    m_left=m_leftBottom;
  
 if((m_rightUp-m_rightBottom)<=0)
    m_right=m_rightUp;
 else
    m_right=m_rightBottom;
  
 if(m_left <= m_right)
 {
    return m_obj;
 }
 else
 {  //有可能为空,NULL
    return m_obj.nextSibling;
 }
}

function f_findInArray(m_obj)
{
 var i=0;
 while(i < g_selected_elements.length)
 {
    if(m_obj == g_selected_elements[i])
       return true;
    i++;
 }
 return false;
}

// 清空g_selected_elements
function f_emptyAray()
{
 while(g_selected_elements.length>0)
 {
    var m_temp = g_selected_elements.pop();
  
    if(f_in_border_ele(m_temp.tagName)==-1)
       m_temp.style.border  = '';
    else
       m_temp.style.outline = '';
 } 
   return;
}
 
// 初始化函数
function f_shiftAttriBar()
{
// g_attriWindow.moveTo(document.getElementById(g_tool_boxWindow_id).boxObject.x,
//                      document.getElementById(g_tool_boxWindow_id).boxObject.y);
}
 
/*
 * 这是整个IDE相关的
 */
function RSWXULEdit_init()
{ 
  try{
      //Set workspace_navigator width,Only for beauty.
      document.getElementById(g_workspace_navigator_id).setAttribute('width',document.getElementById(g_workspace_navigator_id).boxObject.width);
      document.getElementById(g_workspace_navigator_id).removeAttribute('flex');
      document.getElementById(g_tool_boxWindo_box_id).setAttribute('width',document.getElementById(g_tool_boxWindo_box_id).boxObject.width);
      document.getElementById(g_tool_boxWindo_box_id).removeAttribute('flex');
      document.getElementById(g_work_areaWindow_id).setAttribute('width','200');
      var obj =new Object();
      g_attriWindow=window.openDialog("./XUL/Property.xul","_blank",
      "resizable,scrollbars,dialog=yes,close,modal=no,dependent,width=210,height=436,toolbar=yes ",obj);
   
      if(null!=g_attriWindow)
      {
           g_attriWindow.moveTo(document.getElementById(g_tool_boxWindo_box_id).boxObject.screenX,300);
           g_attriWindow.document.documentElement.setAttribute('pre_x',g_attriWindow.screenX);
           g_attriWindow.document.documentElement.setAttribute('pre_y',g_attriWindow.screenY);
         
      }
  }catch(e){
     alert('Exception from Edit.js RSWXULEdit_init() '+e);
     throw e;
  }
}
 
/*
 * Function of ondraggesture message of ToolKit.It's a bubble message,defined inside the tag.
 */
 function RSWf_toolbox_select(event)
 {    
    //Set the cursor style of ToolKit.
    var m_tool_box=document.getElementById(g_tool_boxWindow_id);
    m_tool_box.setAttribute('style', 'cursor:url(./image/cursors/rsno.cur),wait;');
    try{ 
         if('treechildren'==event.target.tagName)
         {
              var m_toolKitTree = m_tool_box;
              var m_toolKitTreeItem = m_toolKitTree.contentView.getItemAtIndex(m_toolKitTree.currentIndex);
              var m_toolKitTreeItemcell = m_toolKitTreeItem.firstChild.firstChild;
              var m_newElement = m_toolKitTreeItemcell.getAttribute('widgetName').toLowerCase();
         
              if(m_newElement!='')
              {
                   if(m_newElement=='restoremouse')
                   {
                      g_message.pop();
                   }
                   else 
                   {
                      g_message.pop();
                      g_message.push(f_ConMessageWithEvent(event,g_mousedownMessageflag,m_newElement)); 
                   }
              }
              return; 
         }
     }catch(e){
        alert('Exception from Edit.js RSWf_toolbox_select() '+e);
        throw e;
     }
}

/* 
 * This function is for another js file using
 */
function RSWXULShow(xul_component,panel_obj,tab_obj)
{ 
 try{ 
     var m_xul_doc;
     m_xul_doc=xul_component.QueryInterface(CI.nsIRSXULDocument); 
     if(null!=g_attriWindow)
     {   
          g_attriWindow.RSF_clearProlist();
          g_attriWindow.RSF_openDocument(m_xul_doc);
          var ea = document.createEvent("MouseEvent");
          ea.initMouseEvent("null", true, false, window,
                             0,0 ,0,
                             0 ,0,false, 
                             false,false,
                             false,0, null);
          ea.rsShow = true;
          RSWViewArrtibuteBar(ea);
     }
     
     var oDocument = document;  
     var oRSEdge = oDocument.createElement('RS_edge');
     var oRSlabel= oDocument.createElement('rslabel');
     var oRSDes  = oDocument.createElement('rsdescription');
     var oScrollbox = oDocument.createElement('scrollbox');
     oRSEdge.setAttribute('class','xulelement');
     oRSEdge.setAttribute('hidden','true');
     oRSlabel.setAttribute('hidden','true');
     oRSDes.setAttribute('hidden','true');
     oScrollbox.setAttribute('style','overflow: auto;border: double 1px;');
     oScrollbox.setAttribute('flex','1');
     oScrollbox.setAttribute('orient','vertical');
     var m_stack = oDocument.createElement('stack');
     m_stack.setAttribute('flex','1');
     m_stack.setAttribute('id','stack'+m_xul_doc.ID);
     m_stack.setAttribute('style','background-color: #FDF5E6;-moz-user-focus:normal;');
     m_xul_doc.DOMNode.setAttribute('left','0');
     m_xul_doc.DOMNode.setAttribute('top' ,'0');
     m_xul_doc.DOMNode.setAttribute('flex','1');
     m_stack.appendChild(m_xul_doc.DOMNode);
     m_stack.appendChild(oRSEdge);
     m_stack.appendChild(oRSlabel);
     m_stack.appendChild(oRSDes);
     oScrollbox.appendChild(m_stack);
     panel_obj.appendChild(oScrollbox);
     panel_obj.setAttribute('RSXULDocId',xul_component.ID);
     panel_obj.setAttribute('flex','1');
     panel_obj.setAttribute('style','background-color: #FDF5E6;');
     oScrollbox.setAttribute('width' ,panel_obj.boxObject.width);
     oScrollbox.setAttribute('height',panel_obj.boxObject.height);
      
     if((m_xul_doc.DOMNode.getAttribute('height')=='')||(m_xul_doc.DOMNode.getAttribute('width')==''))
     {
        m_xul_doc.DOMNode.setAttribute('height',panel_obj.boxObject.height/2);
        m_xul_doc.DOMNode.setAttribute('width' ,panel_obj.boxObject.width*3/4);
     }
      
     m_stack.setAttribute('minheight',panel_obj.boxObject.height*9/10);
     m_stack.addEventListener('mousedown',f_attach       ,true);
     m_stack.addEventListener('mousemove',f_doc_mousemove,true);
     m_stack.addEventListener('mouseup'  ,f_doc_mouseup  ,true);
     m_stack.addEventListener('mousedown',f_doc_mousedown,true);
     m_stack.addEventListener('keypress' ,RSWf_key_      ,true);
      
     g_selected_array[xul_component.ID] = new Array();
     panel_obj.parentNode.parentNode.selectedTab = tab_obj;
     
     // If the opened XUL document has a flex attribute
     if(''!=m_xul_doc.DOMNode.getAttribute('flex'))
     {
        // If width not deleted, the flex will not effect
        m_xul_doc.DOMNode.removeAttribute('width');
        m_xul_doc.DOMNode.setAttribute('flex','1');
     }
    
     if(0==m_xul_doc.DOMNode.boxObject.width)
        m_xul_doc.DOMNode.setAttribute('width','400');
     if(0==m_xul_doc.DOMNode.boxObject.height)
        m_xul_doc.DOMNode.setAttribute('height','400');
        
  }catch(e){
      alert('Exception from Edit.js RSWXULShow() '+e);
      throw e;
  }
  return 0;
}

function RSWSchemaShow(m_rdfConfig ,panel_obj)
{
  try{
      var xulScrollString = '<scrollbox id="temp" style="overflow: auto;border: double 1px;" orient="vertical"  flex="1" xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul"/>'
      var parser=new DOMParser();
      var resultScroll = parser.parseFromString(xulScrollString,"text/xml");
      var m_scrollbar  = resultScroll.documentElement;
      m_scrollbar.setAttribute('width' ,panel_obj.boxObject.width);
      m_scrollbar.setAttribute('height',panel_obj.boxObject.height);
      var oScrollBar = document.importNode(m_scrollbar,true);
      oScrollBar.appendChild(m_rdfConfig);
      panel_obj.appendChild(oScrollBar);
      m_rdfConfig.setAttribute('src','SCM/SchemaEdit.xul');
  }catch(e){
     alert('Exception from Edit.js RSWSchemaShow() '+e);
  }
}

function RSW_move_message(event)
{
  try{
      if(g_messageList.length>0)
      {
          for(var i=0;i<g_messageList.length;i++)
          {              
            if(g_messageList[i][0].parentNode!=null)
            {
               g_messageList[i][0].edge_move(g_messageList[i][1],event,1,1);
               /*
               var m_DocId = RSWf_getCurrentXULDoc().ID;
 
               var m_nodeList = document.getElementById('stack'+m_DocId).getElementsByTagName('RS_edge');
               
               for(var j=0;j<m_nodeList.length;j++)
                 {  
                   try{
                   if((m_nodeList[j]!=g_messageList[i][0]) && (m_nodeList[j].RS_edge_getAttribute('id')!='m_edge'))
                   { 
                     m_nodeList[j].edge_move(g_messageList[i][1],event,1,1);
                   }
                    }catch(e)
                           {
                            alert(e);
                           }
                        
                 }*/
            }
                
            f_repaint(event);
          }
      } 
     //Close the tooltip popup
     // if('true'!=document.getElementById('RSWTip1').getAttribute('hidden'))
     //     document.getElementById('RSWTip1').setAttribute('hidden','true');
     // event.stopPropagation();
     // event.preventDefault();
   }catch(e){
       alert('Exception from Edit.js RSW_move_message() '+e);
   }
} 

function RSW_clear_message(event)
{ 
  if(g_messageList.length>0)
  {
      for(var i=0;i<g_messageList.length;i++)
      {  
          if(g_messageList[i][0].parentNode!=null)
          {    
               g_messageList[i][0].edge_mouseup(g_messageList[i][1]);  
               var m_Doc = RSWf_getCurrentXULDoc();
               var correspond_id  =  g_messageList[i][0].getAttribute('correspond_id');
               var correspond_type=  g_messageList[i][0].getAttribute('correspond_type');
               var correspond_obj = m_Doc.RSXULGetAgencyELementById(correspond_id,correspond_type);
  
               if(null!=g_attriWindow)
               {
                   g_attriWindow.f_showAttribute(correspond_obj);
               }
               /*
               var m_DocId = RSWf_getCurrentXULDoc().ID;
               var m_nodeList = document.getElementById('stack'+m_DocId).getElementsByTagName('RS_edge');
               for(var j=0;j<m_nodeList.length;j++)
               {
                   if((m_nodeList[j]!=g_messageList[i][0]) && (m_nodeList[j].RS_edge_getAttribute('id')!='m_edge'))
                       m_nodeList[j].edge_mouseup(g_messageList[i][1]);  
               }*/
          }
          g_messageList.splice(i,1);
          i--;
      }
          
      for(i=0;i<g_message.length;i++)
      { 
          g_message.splice(i,1);
          i--;
      }
   }
  
   for(i=0;i<g_message.length;i++)
   {
     try{
         var m_message_eventObj_id = g_message[i].target.parentNode.parentNode.parentNode.parentNode.id;
     }catch(e){
         m_message_eventObj_id = '';
     }
      
     if((m_message_eventObj_id!='tool_box_window') &&(g_message[i].type != 'draggesture'))
     {
       try{
           g_mousedownMessageflag = false;
           f_pop_message(f_ConMessageWithEvent(event,g_mousedownMessageflag));
       }catch(e){
          alert('Exception from Edit.js f_doc_mouseup() '+e);
       }
     }
   }
   return 0;
}

function RSWf_workareaCommand(event)
{
 //g_attriWindow.f_showAttribute(event.target);
}

function RSWViewArrtibuteBar(event)
{ 
 try{  
     if(null!=g_attriWindow && event.rsShow==null)
     {   
        if(g_attriWindow.screenX<window.screen.width)
        {   
           g_attriWindow.document.documentElement.setAttribute('pre_x',g_attriWindow.screenX);
           g_attriWindow.document.documentElement.setAttribute('pre_y',g_attriWindow.screenY);
           g_attriWindow.document.documentElement.setAttribute('RShidden','true');
           g_attriWindow.moveTo(window.screen.width,window.screen.height);
        }
        else
        { 
           if('true'==g_attriWindow.document.documentElement.getAttribute('RShidden')) 
           {
               g_attriWindow.moveTo(g_attriWindow.document.documentElement.getAttribute('pre_x'),
                                    g_attriWindow.document.documentElement.getAttribute('pre_y'));
               g_attriWindow.focus();
               g_attriWindow.document.documentElement.setAttribute('RShidden','false');
           }
        }
     }
     else 
     {
        if(null!=g_attriWindow)
        {  
           if(event.rsShow==false)
           {   
               if(g_attriWindow.screenX<window.screen.width)
               {
                   g_attriWindow.document.documentElement.setAttribute('pre_x',g_attriWindow.screenX);
                   g_attriWindow.document.documentElement.setAttribute('pre_y',g_attriWindow.screenY);
                   g_attriWindow.moveTo(window.screen.width,window.screen.height);
                   g_attriWindow.document.documentElement.setAttribute('RShidden','false');
               }
           }
           else
           {   
               if('false'==g_attriWindow.document.documentElement.getAttribute('RShidden')) 
               {
                   if(g_attriWindow.screenX>=window.screen.width)
                   {    
                         g_attriWindow.moveTo(g_attriWindow.document.documentElement.getAttribute('pre_x'),
                                              g_attriWindow.document.documentElement.getAttribute('pre_y'));
                   }
                   g_attriWindow.focus();
               }
           }
        }
     }
  }catch(e){
      alert('Exception from Edit.js RSWViewArrtibuteBar() '+e);
      throw e;
  }
}

function RSWf_getCurrentDocId()
{
     var tree = document.getElementById("RSWNTree");
     var tds = tree.database.GetDataSources();
     var c = tree.currentIndex;
     var rs = tree.builderView.getResourceAtIndex(c); 
     var id = rs.Value;
     return id;
}

function RSWf_getCurrentXULDoc()
{
 try{
     var m_nowTabpanel = document.getElementById(g_work_areaWindow_id).selectedPanel;   
    
     if(m_nowTabpanel!=null)
     {
        var m_nowDocNodeId= m_nowTabpanel.getAttribute('RSXULDocId');
      
        if(m_nowDocNodeId!='')
        {
            var m_nowDocNode  = g_w.AllNodes.getValue(m_nowDocNodeId);
          
            if(m_nowDocNode!=null)
            {
               var m_nowDoc = m_nowDocNode.QueryInterface(CI.nsIRSXULDocument);
            }
            else
            {
               return null;
            }
        }
        else
        {
            return null;
        }
     }
     else
     {
         return null;
     }
     
     return m_nowDoc;    
 }catch(e){
    alert('Exception from Edit.js RSWf_getCurrentXULDoc() '+e);
    return null;
 }
}

/* This function is called by the splitter of workspace.xul.
 * It is only for the convenience of operation
 */
function f_flex(event)
{
  var m_state = event.target.getAttribute('state');
  if(m_state=='open')  
     event.target.setAttribute('state','collapsed');
  else
     event.target.setAttribute('state','open');
}

/* ********************************************************************************************
 * Menubar command function
 * ********************************************************************************************
 */
 /* *********************************************************************************
  * The command function of "Reset Password" menu of IDE 
  * *********************************************************************************
  */
 function RSWMenuSetupPopPasswordChange(event)
 {
    try{
        // workspace tabs
        var mtabs = document.getElementById("RSWEditTabtabs");
        // workspace tabpanels
        var mpanels = document.getElementById("RSWEditTabtabpanels");
        var newTab= document.createElement("tab");
        var newTabpanel= document.createElement("tabpanel");
        newTab.setAttribute("label","重设密码");
        mpanels.appendChild(newTabpanel);
        mtabs.appendChild(newTab);
        // workspace tabbox
        var selTab=document.getElementById('RSWEditTab');
        selTab.selectedTab=newTab;
        
        var newIframe = document.createElement("iframe");
        newIframe.setAttribute("flex","1");
        newIframe.setAttribute("src","chrome://RealSo/content/APP/SS/RSChangpassword.xul");
        newTabpanel.appendChild(newIframe);
        
    }catch(e){
        alert('Edit.js RSWMenuSetupPopPasswordChange() '+e );
        throw e;
    }
 }
 //////////////////////////////////////////////
 //////////////////Layout menu/////////////////
 //////////////////////////////////////////////
 function RSWMenuLayoutShow(event)
 {
  
  
  
 }
      
 //////////////////////////////////////     
 function f_MenuLayout_attr(m_attr,inner_event)
 {
  try{
      var m_Doc   = RSWf_getCurrentXULDoc();
           
      if(m_Doc!=null)
      {
          var m_DocId = m_Doc.ID;
          var m_array_len = g_selected_array[m_DocId].length;
          var m_standardLength = '';
          
          while(m_standardLength=='')
          {
              m_standardLength = g_selected_array[m_DocId][m_array_len-1].m_element_obj.getAttribute(m_attr);
              m_array_len--;
          }
                
          if(m_standardLength!='')
          {
              for(var i=0;i<g_selected_array[m_DocId].length-1;i++)
              {
                   m_Doc.SetAttribute(m_attr,m_standardLength,g_selected_array[m_DocId][i].m_element_obj);
              }
                       
              f_repaint(inner_event);
          }
      }
       
      return 0; 
   }catch(e){
      alert('Exception from Edit.js f_MenuLayout_attr() '+e);
      throw e;
   }
 }
 //////////////////////////////////////     
 function RSWMenuLayout_length(event)
 {
   f_MenuLayout_attr('height' ,event);
 }
 
 function RSWMenuLayout_width(event)
 {
   f_MenuLayout_attr('width' ,event);
 }
 
 function RSWMenuLayout_both(event)
 {
   f_MenuLayout_attr('height',event);
   f_MenuLayout_attr('width' ,event);
 }
 
 function RSWMenuLayout_left(event)
 {
  try{
      var m_Doc   = RSWf_getCurrentXULDoc();
       
      if(m_Doc!=null)
      {
          var m_DocId = m_Doc.ID;
          var m_array_len = g_selected_array[m_DocId].length;
          var m_standardLength = Number.NaN;
             
          while(isNaN(m_standardLength))
          { 
              m_standardLength = parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.left);
              m_array_len--;
          }
            
          if(!isNaN(m_standardLength))
          {
              for(var i=0;i<m_array_len;i++)
              {
                  if(f_judgeContainer(g_selected_array[m_DocId][i].m_element_obj.parentNode)==1)
                      m_Doc.SetAttribute('left',m_standardLength,g_selected_array[m_DocId][i].m_element_obj);
              }
                   
              f_repaint(event);
          }
      }
      
      return 0;  
   }catch(e){
      alert('Exception from Edit.js RSWMenuLayout_left() '+e);
   }
 }
 
 function RSWMenuLayout_right(event)
 {
  try{
      var m_Doc = RSWf_getCurrentXULDoc();
        
      if(m_Doc!=null)
      {
          var m_DocId = m_Doc.ID;
          var m_array_len = g_selected_array[m_DocId].length;
          var m_standardLength = Number.NaN;
             
          while(isNaN(m_standardLength))
          { 
              m_standardLength = parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.left) + parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.boxObject.width);
              m_array_len--;
          }
          if(!isNaN(m_standardLength))
          {
              for(var i=0;i<m_array_len;i++)
              {
                  if(f_judgeContainer(g_selected_array[m_DocId][i].m_element_obj.parentNode)==1)
                      m_Doc.SetAttribute('left',m_standardLength-parseInt(g_selected_array[m_DocId][i].m_element_obj.width),g_selected_array[m_DocId][i].m_element_obj);
              }
                   
              f_repaint(event);
          }
      }
      
      return 0;  
   }catch(e){
      alert('Exception from Edit.js RSWMenuLayout_right() '+e);
  }
 }
 
 function RSWMenuLayout_center(event)
 {
  try{
      var m_Doc = RSWf_getCurrentXULDoc();
        
      if(m_Doc!=null)
      {
          var m_DocId = m_Doc.ID;
          var m_array_len = g_selected_array[m_DocId].length;
          var m_standardLength = Number.NaN;
          while(isNaN(m_standardLength))
          {
              m_standardLength = 2*parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.left) + parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.boxObject.width);
              m_array_len--;
          }
          if(!isNaN(m_standardLength))
          {
              for(var i=0;i<m_array_len;i++)
              {
                  if(f_judgeContainer(g_selected_array[m_DocId][i].m_element_obj.parentNode)==1)
                      m_Doc.SetAttribute('left',(m_standardLength-parseInt(g_selected_array[m_DocId][i].m_element_obj.width))/2,g_selected_array[m_DocId][i].m_element_obj);
              }
                 
              f_repaint(event);
          }
      }
      
      return 0;  
  }catch(e){
     alert('Exception from Edit.js RSWMenuLayout_center() '+e);
  }
 }
 
 function RSWMenuLayout_up(event)
 {
  try{
      var m_Doc = RSWf_getCurrentXULDoc();
        
      if(m_Doc!=null)
      {
          var m_DocId = m_Doc.ID;
          var m_array_len = g_selected_array[m_DocId].length;
          var m_standardLength = Number.NaN;
             
          while(isNaN(m_standardLength))
          { 
              m_standardLength = parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.top);
              m_array_len--;
          }
            
          if(!isNaN(m_standardLength))
          {
              for(var i=0;i<m_array_len;i++)
              {
                   if(f_judgeContainer(g_selected_array[m_DocId][i].m_element_obj.parentNode)==1)
                      m_Doc.SetAttribute('top',m_standardLength,g_selected_array[m_DocId][i].m_element_obj);
              }
                   
              f_repaint(event);
          }
      }
      
      return 0;  
   }catch(e){
      alert('Exception from Edit.js RSWMenuLayout_up() '+e);
   }
 }
 
 function RSWMenuLayout_down(event)
 {
  try{
      var m_Doc = RSWf_getCurrentXULDoc();
        
      if(m_Doc!=null)
      {
          var m_DocId = m_Doc.ID;
          var m_array_len = g_selected_array[m_DocId].length;
          var m_standardLength = Number.NaN;
             
          while(isNaN(m_standardLength))
          { 
              m_standardLength = parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.top) + parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.boxObject.height);
              m_array_len--;
          }
          if(!isNaN(m_standardLength))
          {
              for(var i=0;i<m_array_len;i++)
              {
                   if(f_judgeContainer(g_selected_array[m_DocId][i].m_element_obj.parentNode)==1)
                        m_Doc.SetAttribute('top',m_standardLength-parseInt(g_selected_array[m_DocId][i].m_element_obj.height),g_selected_array[m_DocId][i].m_element_obj);
              }
                  
              f_repaint(event);
          }
      }
      
      return 0;  
   }catch(e){
      alert('Exception from Edit.js RSWMenuLayout_down() '+e);
   }
 }
 
 function RSWMenuLayout_middle(event)
 {
  try{
      var m_Doc = RSWf_getCurrentXULDoc();
        
      if(m_Doc!=null)
      {
          var m_DocId = m_Doc.ID;
          var m_array_len = g_selected_array[m_DocId].length;
          var m_standardLength = Number.NaN;
          while(isNaN(m_standardLength))
          {
              m_standardLength = 2*parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.top) + parseInt(g_selected_array[m_DocId][m_array_len-1].m_element_obj.boxObject.height);
              m_array_len--;
          }
          if(!isNaN(m_standardLength))
          {
              for(var i=0;i<m_array_len;i++)
              {
                   if(f_judgeContainer(g_selected_array[m_DocId][i].m_element_obj.parentNode)==1)
                       m_Doc.SetAttribute('top',(m_standardLength-parseInt(g_selected_array[m_DocId][i].m_element_obj.height))/2,g_selected_array[m_DocId][i].m_element_obj);
              }
                   
              f_repaint(event);
          }
      }
      return 0;
  }catch(e){
     alert('Exception from Edit.js RSWMenuLayout_middle() '+e);
  }
 }
 ///////////////////////////////////////////////
 ///////////////////////////////////////////////
 function RSWNodeSaveAs(event)
 {
   try{
       var m_Doc = RSWf_getCurrentXULDoc();
       
       if(null!=m_Doc)
       {    
           var ddd_nsIFilePicker = Components.interfaces.nsIFilePicker;
           var ddd_fp = Components.classes["@mozilla.org/filepicker;1"]
                              .createInstance(ddd_nsIFilePicker);
           ddd_fp.init(window, "另存文件为", ddd_nsIFilePicker.modeSave);
           ddd_fp.appendFilter("XUL文件","*.xul");
           ddd_fp.appendFilter("所有文件","*.*");
           var res = ddd_fp.show();
           if( (res == ddd_nsIFilePicker.returnOK)||(res == ddd_nsIFilePicker.returnReplace) )
           {
              var thefile = ddd_fp.file;
              m_Doc.SaveXUL(thefile.path);
           }
       }
    }catch(e){
       alert('Exception from Edit.js RSWNodeSaveAs() '+e);
    }
 }
 
 function RSWExit()
 {
   window.close();
 }
 
 function RSWRun(event)
 {
  try{
      RSWTBPreView();
  }catch(e){
     alert('Exception from Edit.js RSWRun() '+e);
  }    
 }
 
 function RSW_wDataSourceConfig(event)
 {
  try{ 
      var m_tabName = document.getElementById(g_work_areaWindow_id).selectedTab;   
      var m_dsConfigWindow = window.openDialog("./XUL/BindConfig4.xul","_blank",
          "centerscreen,dialog=yes,close,modal=yes,dependent",m_tabName.label,'',RSWf_getCurrentXULDoc()); 
  }catch(e){
     alert('Exception from Edit.js RSW_wDataSourceConfig() '+e);
     throw e;
  }
 }
 
 function RSW_wDataSourceConfigApplay(m_ds)
 {
  try{
      var m_Doc   = RSWf_getCurrentXULDoc();
      m_Doc.SetAttribute('RS_datasource',m_ds,m_Doc.DOMNode);
  }catch(e){
      alert('Exception from Edit.js RSW_wDataSourceConfigApplay() '+e);
      throw e;
  }
 }
 
 function RSW_widDataSourceConfigApplay(m_ds,m_fs,m_obj)
 {
  try{
      var m_Doc   = RSWf_getCurrentXULDoc();
      m_Doc.SetAttribute('RS_dstable',m_ds,m_obj);
      m_Doc.SetAttribute('RS_dsfield',m_fs,m_obj);
  }catch(e){
      alert('Exception from Edit.js RSW_widDataSourceConfigApplay() '+e);
  }
 }
 
 function  f_pop(inner_event)
 { 
    if(null!=RSW_getCurrentWindowDS())
    {
         switch (inner_event.target.tagName)
         { 
           case 'tree':
           {
               var m_TreeConfigWindow = window.openDialog("./XUL/TreeConfig.xul","_blank",
               "centerscreen,dialog=yes,close,modal=yes,dependent",RSW_getCurrentWindowDS(),inner_event,RSWf_getCurrentXULDoc()); 
           }       
           break;
           case 'checkbox':
           case 'rslabel':
           case 'textbox':
           case 'datepicker':
           case 'radiogroup':
           {
                var m_EditConfigWindow = window.openDialog("./XUL/BindConfig2.xul","_blank",
                "centerscreen,dialog=yes,close,modal=yes,dependent",RSW_getCurrentWindowDS(),inner_event,RSWf_getCurrentXULDoc()); 
           }
           break;
           case 'rsmenulist':
           {
                var m_rsmenulistConfWindow = window.openDialog("./XUL/BindConfig6.xul",'_blank',
                "centerscreen,dialog=yes,close,modal=yes,dependent",RSW_getCurrentWindowDS(),inner_event,RSWf_getCurrentXULDoc()); 
           }
           break;
           case 'RSmenulist':
           {
                var m_menulistConfWindow = window.openDialog("./XUL/BindConfig1.xul",'_blank',
                "centerscreen,dialog=yes,close,modal=yes,dependent",RSW_getCurrentWindowDS(),inner_event,RSWf_getCurrentXULDoc()); 
           }
           break;
           default:
         }
    }
    else
    {
         if(confirm('Sorry,please config datasource of window first?'))
         {
            RSW_wDataSourceConfig(inner_event);
         }
    }
 }

/* *******************************************************************************
 * Function is used for getting current datasource of window.
 * *******************************************************************************
 */
  function RSW_getCurrentWindowDS()
  {
    try{
        netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
        var m_Doc   = RSWf_getCurrentXULDoc();
        if(null!=m_Doc)
        {
            const CC = Components.classes, CI = Components.interfaces; 
            var rdfs = CC["@mozilla.org/rdf/rdf-service;1"].getService(CI.nsIRDFService);
            var dba = CC["@realso.cn/XPCOM/RSDBAccess;1"].getService(CI.IRSDBAccess);
            var rdfService = Components.classes["@mozilla.org/rdf/rdf-service;1"].
                             getService(Components.interfaces.nsIRDFService);
            var ds = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"]
                     .createInstance(Components.interfaces.nsIRDFDataSource);
             
            var m_document = m_Doc.GetOriginalDoc();
            var m_modelID = m_document.documentElement.getAttribute('RS_datasource');
            if(''!=m_modelID) 
               dba.LoadRDFModel(ds,m_modelID);
            else
               ds = null;             
            return ds;
        }
    }catch(e){
        alert('Exception from Edit.js RSW_getCurrentWindowDS() '+e);
        throw e;
    }
  }
  
  function RSW_popUpMenu(event)
  {
   try{
        var m_Doc = RSWf_getCurrentXULDoc();
        if(null!=m_Doc)
        {
            var m_DocId = m_Doc.ID;
            var m_len = g_selected_array[m_DocId].length;
            var m_event = f_ConMessageWithEvent(event,g_mousedownMessageflag);
            m_event.target = g_selected_array[m_DocId][m_len-1].m_element_obj;
            
            //If the target is a tree children, treechildren,treecell eg.
            if(null!=f_getTreeTabbox(m_event.target,'tree'))
               m_event.target = f_getTreeTabbox(m_event.target,'tree');
            
            f_pop(m_event);
        }
   }catch(e){
        alert('Exception from Edit.js RSW_popUpMenu() '+e);
        throw e;
   }   
  }
  
  function RSW_showSourceFile()
  {
     var m_Doc = RSWf_getCurrentXULDoc();
     if(null!=m_Doc)
     {
         var serializer = new XMLSerializer();
         xml = serializer.serializeToString(m_Doc.DOMNode);
         alert(xml);
     }
  }
  
  function RSW_editScript(event)
  {
    try{
        var m_Doc = RSWf_getCurrentXULDoc();
        if(null!=m_Doc)
        {
            var m_OriginalDoc = m_Doc.GetOriginalDoc();
            var m_scripts = m_OriginalDoc.documentElement.getElementsByTagName('script');
            var m_EditJS = window.openDialog("./XUL/JSEdit.xul","_blank",
                "centerscreen,dialog=yes,close,modal=no,dependent,resizable",m_scripts,m_OriginalDoc.documentElement); 
        }               
        
    }catch(e){
        alert('Exception from Edit.js RSW_editScript() '+e);
    }
  }
  
  function RSW_JScode(event)
  {
    var m_EditJS = window.openDialog("sdf.xul","_blank",
        "centerscreen,dialog=yes,close,modal=no,dependent,resizable",m_scripts,m_OriginalDoc.documentElement); 
           
  }
  
  function RSW_stylesheet(event)
  {
    try{
        var m_Doc = RSWf_getCurrentXULDoc();
        if(null!=m_Doc)
        { 
            var m_OriginalDoc = m_Doc.GetOriginalDoc();
            var m_styleEdit = window.openDialog("./XUL/CSSEdit.xul","_blank",
                "centerscreen,dialog=yes,close,modal=no,dependent,resizable=no",m_OriginalDoc);
        }
    }catch(e){
       alert('Exception from Edit.js RSW_editAtomElement() '+e);
       throw e;
    }
  }
  
  function RSF_ProConf(event)
  {
   try{
       var m_Doc = RSWf_getCurrentXULDoc();
       if(null!=m_Doc)
       {
           var m_DocId = m_Doc.ID;
           var m_len = g_selected_array[m_DocId].length;
            
           if('rsmenulist'==g_selected_array[m_DocId][m_len-1].m_element_obj.tagName)
           {
                var m_menulistConf = window.openDialog("./XUL/BindConfig5.xul","_blank",
                    "centerscreen,dialog=yes,close,modal=no,dependent",g_selected_array[m_DocId][m_len-1].m_element_obj,RSWf_getCurrentXULDoc()); 
           }
       }
   }catch(e){
      alert('Exception from Edit.js RSF_ProConf() '+e);
      throw e;
   }
  }
  
  function RSW_editAtomElement(event)
  {
    try{
        var tag = event.target.getAttribute('value');
        
        switch(tag)
        {
           case 'tree':
           if(RSVisualGlobalSpace.atomElementEdit['tree'])
           {  
               RSVisualGlobalSpace.atomElementEdit['tree'] = false;
           }
           else
           {
               RSVisualGlobalSpace.atomElementEdit['tree'] = true;
           }
           break;
           case 'tabbox':
           if(RSVisualGlobalSpace.atomElementEdit['tabbox'])
              RSVisualGlobalSpace.atomElementEdit['tabbox'] = false;
           else
              RSVisualGlobalSpace.atomElementEdit['tabbox'] = true;
           break;
           case 'grid':
           if(RSVisualGlobalSpace.atomElementEdit['grid'])
              RSVisualGlobalSpace.atomElementEdit['grid'] = false;
           else
              RSVisualGlobalSpace.atomElementEdit['grid'] = true;    
           break;
        }
    }catch(e){
       alert('Exception from Edit.js RSW_editAtomElement() '+e);
       throw e;
    }
  }
 /////////////////////////////////////////////////////////////////////////////////////////////
 
 /* ******************************************************************************************
  * Autosend a message, according to the type of message and target
  * First parameter is  event type;
  * Second parameter is the tagName of event target;
  * Third parameter is the event self
  * 
  * But it is not a universial function 
  ********************************************************************************************
  */
 function RSW_autoSendMessage(e_type, e_tag, e_)
 {  
    try{
        var ea = document.createEvent("MouseEvent"); 
                                
        ea.initMouseEvent(e_type, true, true, window,0,
                           e_.screenX, e_.screenY, e_.clientX, e_.clientY,e_.ctrlKey, 
                           e_.altKey, e_.shiftKey,
                           e_.metKey, e_.button, null);
        /* Because of this event is auto send by the program,pre-mousedown message should be removed from 
         * global message variable.And now We can affirm that the pre-message stored in the message variable 
         * is a mousedown message 
         */
         var correspond_obj = f_getTreeTabbox(e_.target,e_tag);
         
         if(correspond_obj!=null)             
            correspond_obj.dispatchEvent(ea); 
    }catch(e){
        alert('Exception from Edit.js RSW_autoSendMessage() '+e);
        throw e;
    } 
 }
 
 /* *****************************************************************************************
  * universial auto send message function
  * *****************************************************************************************
  */
 function RSF_autoSendMes(e_type, e_tag, e_)
 {
    try{
        var ea = document.createEvent("MouseEvent"); 
                                
        ea.initMouseEvent(e_type, true, true, window,0,
                           e_.screenX, e_.screenY, e_.clientX, e_.clientY,e_.ctrlKey, 
                           e_.altKey, e_.shiftKey,
                           e_.metKey, e_.button, null);
        /* Because of this event is auto send by the program,pre-mousedown message should be removed from 
         * global message variable.And now We can affirm that the pre-message stored in the message variable 
         * is a mousedown message 
         */
         var correspond_obj = e_.target;
        
         if(null!=correspond_obj)             
            correspond_obj.dispatchEvent(ea);
         
         g_message.pop(); 
         
    }catch(e){
        alert('Exception from Edit.js RSF_autoSendMes() '+e);
        throw e;
    } 
 }
 
 /* *****************************************************************************************
  * When user click a tab with left mouse button, the 
  * following function is triggled
  *******************************************************************************************
  */
 function RSF_switchTab(event)
 {
  try{
//      var m_Doc   = RSWf_getCurrentXULDoc();
//      if(null!=m_Doc)
//      {// Is editing XUL
//          if(0==event.button)
//            {
//               if(null!=g_attriWindow)
//                 {
//                    //window.setTimeout(f_a,200,m_Doc.ID,m_Doc.DOMNode);
//                 }  
//            }
//      }
  
  }catch(e){
     alert('Edit.js RSF_switchTab() '+e);
     throw e;
  }
 }
 
 function f_attributeSW(m_Doc)
 { 
   try{
       g_attriWindow.RSF_clearProlist();
       g_attriWindow.RSF_openDocument(m_Doc);
       if(null!=g_selected_array[m_Doc.ID])
       {
           var m_len = g_selected_array[m_Doc.ID].length;
           
           if(m_len>=1)
              g_attriWindow.f_showAttribute(g_selected_array[m_Doc.ID][m_len-1].m_element_obj);
           else
              g_attriWindow.f_showAttribute(m_Doc.DOMNode);
       }
   }catch(e){
       alert('Exception from Edit.js f_attributeSW() '+e);
   }
 }
 
 function RSF_switchTabSel(event)
 {
  try{ 
      event.rsShow=false;
      var tab   = event.target.selectedItem;
      var id = tab.getAttribute("id");
      if(id == "preview" || id =="")
      {// Is editing XUL
        
      }
      else
      {
        if(g_w.AllNodes.getValue(id).Type==3)
        {   
             event.rsShow=true;
             var m_Doc   = RSWf_getCurrentXULDoc();
             if(null!=m_Doc)
             { 
                  if(null!=g_attriWindow)
                  {
//                        window.setTimeout(f_attributeSW,300,m_Doc);
//                        g_attriWindow.RSF_clearProlist();
//                        g_attriWindow.RSF_openDocument(m_Doc);
//                         
//                        var m_len = g_selected_array[m_Doc.ID].length;
//                        if(m_len>=1)
//                        { 
//                          g_attriWindow.f_showAttribute(g_selected_array[m_Doc.ID][m_len-1].m_element_obj);
//                        }
//                         else
//                         { 
//                          g_attriWindow.f_showAttribute(m_Doc.DOMNode);
//                         }
                   }  
              }
              else
              {
                    alert('null');
              }
         }
       }
       RSWViewArrtibuteBar(event);
  }catch(e){
     alert('Exception from Edit.js RSF_switchTab() '+e);
     throw e;
  }
 }
 
 function RSFDelSelEles()
 {
  try{
     var m_nowTabpanel = document.getElementById(g_work_areaWindow_id).selectedPanel;   
  
     if(m_nowTabpanel!=null)
     {
       var m_nowDocNodeId= m_nowTabpanel.getAttribute('RSXULDocId');
      
        if(m_nowDocNodeId!='')
        {   var i=0;
            while(0!=g_selected_array[m_nowDocNodeId].length)
            {
               g_selected_array[m_nowDocNodeId].pop();
              //delete g_selected_array[m_nowDocNodeId][i]
              //i++;
            }
            delete g_selected_array[m_nowDocNodeId];
        }
        
        g_attriWindow.fClearGlobal();
     }
  }catch(e){
     alert('Exception from Edit.js RSFDelSelEles() '+e);
  }
 }
 
 function RSW_InsertNewElement(event)
 {
  try{
      var m_Doc = RSWf_getCurrentXULDoc();
        
      if(null!=m_Doc)
      {
          var m_DocId = m_Doc.ID;
          var m_len = g_selected_array[m_DocId].length;
           
          var m_event = f_ConMessageWithEvent(event,g_mousedownMessageflag);
          m_event.target = g_selected_array[m_DocId][m_len-1].m_element_obj;
      }
      var temp=window.openDialog("./XUL/InsertAppend.xul","_blank",
           "dialog=yes,close,modal=yes,dependent,centerscreen ",m_event,'insert');       
  
  }catch(e){
     alert('Exception from Edit.js RSW_InsertNewElement() '+e);
  }
 }
 
 function RSW_AppendNewElement(event)
 {
  try{
      var m_Doc = RSWf_getCurrentXULDoc();
        
      if(null!=m_Doc)
      {
          var m_DocId = m_Doc.ID;
          var m_len = g_selected_array[m_DocId].length;
           
          var m_event = f_ConMessageWithEvent(event,g_mousedownMessageflag);
          m_event.target = g_selected_array[m_DocId][m_len-1].m_element_obj;
            
          // If the target is a tree children, treechildren,treecell etc.
          // Since tree and tabbox,etc. as a atomElement, you cannot select a treecol and tab or so.
          // The following code may be not need.
          var m_flag = true;
          var m_atomEleFl = RSVisualGlobalSpace.g_atomElementFather;
          for(var j=0;j<m_atomEleFl.length;j++)
          {
               if((null!=f_getTreeTabbox(m_event.target,m_atomEleFl[j]))&&
                   (RSVisualGlobalSpace.atomElementEdit[m_atomEleFl[j]]))
               {
                     m_flag = false;
                     break;
               }
          }
            
          // If the element is a normal xul element, directly select
          if(m_flag)
          {  
              
          } // If the element is a tree, tabbox etc.
          else
          {
               if(RSVisualGlobalSpace.VisualCurrentState=='default') 
               {
                   // At the default state , you can not select atomElement Child.
                   var m_atom = RSVisualGlobalSpace.g_atomElementFather;
                         
                   for(var i=0;i<m_atom.length;i++)
                   {
                       if((f_getTreeTabbox(m_event.target,m_atom[i])!=null)&&
                          (RSVisualGlobalSpace.atomElementEdit[m_atom[i]]))
                       {
                           m_event.target = f_getTreeTabbox(m_event.target,m_atom[i]);    
                       }
                   }
                }
                else
                {
                                
                } 
          }
      }
      var temp=window.openDialog("./XUL/InsertAppend.xul","_blank",
          "dialog=yes,close,modal=yes,dependent,centerscreen ",m_event,'append');
  }catch(e){
     alert('Exception from Edit.js RSW_AppendNewElement() '+e);
  }
 }
 
 function RSW_Copy(event)
 {
  try{
      fSelectArraysCleanUp('copy');
      document.getElementById('cmd_paste').removeAttribute('disabled');
      f_repaint(event);
  }catch(e){
     alert('Exception from Edit.js RSW_Copy() '+e);
  }
 }
 
 function RSW_Cut(event)
 {
  try{
      fSelectArraysCleanUp('cut');
      document.getElementById('cmd_paste').removeAttribute('disabled');
      f_repaint(event);
  }catch(e){
     alert('Exception from Edit.js RSW_Cut() '+e);
  }
 }
 
 function RSW_Plaster(event)
 {
  try{
      fClipboardGet(event);
  }catch(e){
     alert('Exception from Edit.js RSW_Plaster() '+e);
  }
 }
 
 function fSelectArraysCleanUp(OperaType)
 {
  try{
      // Test whether the parent element of the node exist in the array afters.
      // If exist, do nothing;else copy it to the new Array; 
      var m_Doc = RSWf_getCurrentXULDoc();
      var originalWindowId = m_Doc.DOMNode.id;
      var retArrays = new Array();
      
      // storing the xml in the agency document
      var agencyXML = document.createElement('agency');
      // storing the xml in the original document
      var originalXML = document.createElement('original');
      
      if(null!=m_Doc)
      {     
          var m_DocId = m_Doc.ID;
          var temp;
            
          // If the User selected lots of elements, we should determine which element can be 
          // deleted. Because one element may be the parent of the other element, etc.
          for(var i=0;i<g_selected_array[m_DocId].length;i++)
          {     
                var find = false;
                temp = g_selected_array[m_DocId][i].m_element_obj;
                  
                while((null!=temp)&&(originalWindowId!=temp.id))
                {
                     temp = temp.parentNode;
                       
                     for(var j=0;j<g_selected_array[m_DocId].length;j++) 
                     {
                        if(i!=j)
                        {
                           if(temp.id==g_selected_array[m_DocId][j].m_element_obj.id)
                           {
                                find = true;
                           }
                        }
                     } // for
                } // while
                  
                if(!find)
                {
                   retArrays.push(g_selected_array[m_DocId][i]);
                }
          } // for
         
      
          if('copy'==OperaType)
          {
              if('window'!=m_Doc.RSXULGetElementById(retArrays[0].m_element_obj.id).tagName)
              {
                    for(var i=0;i<retArrays.length;i++)
                    {
                        var temp    = retArrays[i].m_element_obj.cloneNode(true);
                        var tempOri = m_Doc.RSXULGetElementById(retArrays[i].m_element_obj.id).cloneNode(true);
                        agencyXML.appendChild(temp);
                        tempOri = document.importNode(tempOri,true);
                        originalXML.appendChild(tempOri);
                    }
              }
              else
              {
                    for(var j=0;j<retArrays[0].m_element_obj.childNodes.length;j++)
                    {
                        var temp    = retArrays[0].m_element_obj.childNodes[j].cloneNode(true);
                        var tempOri = m_Doc.RSXULGetElementById(retArrays[0].m_element_obj.childNodes[j].id).cloneNode(true);
                        agencyXML.appendChild(temp);
                        tempOri = document.importNode(tempOri,true);
                        originalXML.appendChild(tempOri);
                    } 
              }
          }
          else
          {
              // remove the selected Edge of the selected elements
              for(var i=0;i<g_selected_array[m_DocId].length;i++)
              {
                    var m_seld = g_selected_array[m_DocId][i].m_element_obj;
                  
                    // The agency document itself can not be deleted.
                    if(m_seld==m_Doc.DOMNode)
                    {
                       continue;
                    }
                    
                    var m_unique_edgeID = m_DocId+g_partion; 
                    var m_p = document.getElementById('stack'+m_DocId).removeChild(document.getElementById(m_unique_edgeID+m_seld.id));
                    g_selected_array[m_DocId].splice(i,1);
                    i--;
              }
               
              if('window'!=m_Doc.RSXULGetElementById(retArrays[0].m_element_obj.id).tagName)
              {
                    for(var i=0;i<retArrays.length;i++)
                    {
                        var m_seld = retArrays[i].m_element_obj;
                      
                        // The agency document itself can not be deleted.
                        if(m_seld==m_Doc.DOMNode)
                        {
                           continue;
                        }
                     
                        var temp    = retArrays[i].m_element_obj;
                        var tempOri = m_Doc.RSXULGetElementById(retArrays[i].m_element_obj.id);
                     
                        // Because importNode function will not remove tempOri object from the original 
                        // document, we have to remove it first.
                        m_Doc.RSXULRemove(temp);
                        agencyXML.appendChild(temp);
                        tempOri = document.importNode(tempOri,true);
                        originalXML.appendChild(tempOri);
                      
                        if(null!=g_attriWindow)
                        {
                            g_attriWindow.f_delAttribute(m_seld);
                        }
                        retArrays.splice(i,1);
                        i--;
                    }
               }
               else
               {
                    while(0!=retArrays[0].m_element_obj.childNodes.length)
                    {
                         var temp    = retArrays[0].m_element_obj.childNodes[0];
                         var tempOri = m_Doc.RSXULGetElementById(retArrays[0].m_element_obj.childNodes[0].id);
                             
                         // Because importNode function will not remove tempOri object from the original 
                         // document, we have to remove it first.
                         m_Doc.RSXULRemove(temp);
                         agencyXML.appendChild(temp);
                         tempOri = document.importNode(tempOri,true);
                         originalXML.appendChild(tempOri);
                     } 
                          
                     retArrays[0].m_element_obj.setAttribute('width','250');
                     retArrays[0].m_element_obj.setAttribute('height','250');
                     if(null!=g_attriWindow)
                     {
                         g_attriWindow.f_delAttribute(m_seld);
                     }
                     retArrays.pop();
               }
          }
      var mClipboard = document.createElement('clipboard');  
      var serializer = new XMLSerializer();
      mClipboard.appendChild(agencyXML);
      mClipboard.appendChild(originalXML);
      var xml = serializer.serializeToString(mClipboard);
      fClipboard(xml);
     } 
     return retArrays;
  }catch(e){
     alert('Exception from Edit.js fSelectArraysCleanUp() '+e);
  }
 }
 
 function fClipboard(CopyText)
 {
  try{
      // step 1: create a xpcom wraper for storing the text 
      var copytext="Text to copy";
      var str = Components.classes["@mozilla.org/supports-string;1"].
                                  createInstance(Components.interfaces.nsISupportsString);
      str.data=CopyText;
      
      // step 2: create a xpcom transferable object
      var trans = Components.classes["@mozilla.org/widget/transferable;1"].
                                  createInstance(Components.interfaces.nsITransferable);
      trans.addDataFlavor("text/unicode");
      trans.setTransferData("text/unicode",str,CopyText.length * 2); 
      
      // setp 3: create a clipboard object which refer to the system clipboard
      var clipid = Components.interfaces.nsIClipboard; 
      var clip = Components.classes["@mozilla.org/widget/clipboard;1"].getService(clipid); 
      clip.setData(trans,null,clipid.kGlobalClipboard); 
        
  }catch(e){
     alert('Exception from Edit.js fClipboard() '+e);
  }
 }
 
 function fClipboardCheck()
 {
  try{
      // step  1:create a clipboard object which refers to the system clipboard
      var clip = Components.classes["@mozilla.org/widget/clipboard;1"].
                 getService(Components.interfaces.nsIClipboard); 
      if(!clip)
      {  
          document.getElementById('cmd_paste').setAttribute('disabled',true);
          return false;
      }
      
      var sArrs = Components.classes['@mozilla.org/supports-array;1'].
                  createInstance(Components.interfaces.nsISupportsArray); 
      var sStr  = Components.classes['@mozilla.org/supports-cstring;1'].
                  createInstance(Components.interfaces.nsISupportsCString); 
      sStr.data = "text/unicode";
      sArrs.AppendElement(sStr);
      var has = clip.hasDataMatchingFlavors(sArrs,clip.kGlobalClipboard); 
     
      if(!has)
      {
         document.getElementById('cmd_paste').setAttribute('disabled',true);    
         return false;
      }
      // step 2:create a transferable object which implements the nsITransferable interface 
      var trans = Components.classes["@mozilla.org/widget/transferable;1"].
                  createInstance(Components.interfaces.nsITransferable); 
      if (!trans)
      {
          document.getElementById('cmd_paste').setAttribute('disabled',true); 
          return false;
      }
      trans.addDataFlavor("text/unicode"); 
      
      // step 3: get data from the system clipboard
      clip.getData(trans,clip.kGlobalClipboard);
      var str = new Object(); 
      var strLength = new Object(); 
     
      trans.getTransferData("text/unicode",str,strLength); 
      
      if (str) 
        str = str.value.QueryInterface(Components.interfaces.nsISupportsString); 
      if (str)
        pastetext = str.data.substring(0,strLength.value / 2); 
      
      var parser = new DOMParser();
      
      var doc = parser.parseFromString(pastetext, "text/xml");
     
      var AgencyNodes =  doc.getElementsByTagName('agency');
      var OrigNodes   =  doc.getElementsByTagName('original');
  
      if(null==AgencyNodes[0])
          document.getElementById('cmd_paste').setAttribute('disabled',true);
  
  }catch(e){
     alert('Exception from Edit.js fClipboardCheck() '+e);
  }
 }
 
 function fClipboardGet(event)
 {
  try{
      // step  1:create a clipboard object which refers to the system clipboard
      var clip = Components.classes["@mozilla.org/widget/clipboard;1"].
                 getService(Components.interfaces.nsIClipboard); 
      if(!clip)
          return false;
      
      // step 2:create a transferable object which implements the nsITransferable interface 
      var trans = Components.classes["@mozilla.org/widget/transferable;1"].
                  createInstance(Components.interfaces.nsITransferable); 
      if (!trans) 
          return false;
      trans.addDataFlavor("text/unicode"); 
      
      // step 3: get data from the system clipboard
      clip.getData(trans,clip.kGlobalClipboard);
      var str = new Object(); 
      var strLength = new Object(); 
      trans.getTransferData("text/unicode",str,strLength); 
      
      if (str) 
        str = str.value.QueryInterface(Components.interfaces.nsISupportsString); 
      if (str)
        pastetext = str.data.substring(0,strLength.value / 2); 
      
      var parser = new DOMParser();
      var doc = parser.parseFromString(pastetext, "text/xml");
      
      var AgencyNodes =  doc.getElementsByTagName('agency');
      var OrigNodes   =  doc.getElementsByTagName('original');
      
      var m_Doc = RSWf_getCurrentXULDoc();
      
      var m_DocId = m_Doc.ID;
      var m_len = g_selected_array[m_DocId].length;
      
      var m_event = f_ConMessageWithEvent(event,g_mousedownMessageflag);
      m_event.target = g_selected_array[m_DocId][m_len-1].m_element_obj;
      m_event.screenX = gScreenXMouse;
      m_event.screenY = gScreenYMouse;  
      
      //If the target is a tree children, treechildren,treecell eg.
      if(null!=f_getTreeTabbox(m_event.target,'tree'))
         m_event.target = f_getTreeTabbox(m_event.target,'tree'); 
      
      var oAgencyNode = document.importNode(AgencyNodes[0],true);
      var oOrigNode   = document.importNode(OrigNodes[0],true);
      while(0!=oAgencyNode.childNodes.length)
      {
           var m_newElement = oAgencyNode.childNodes[0];
           var m_newElementCopy = oOrigNode.childNodes[0];
           
           var mRet = f_add_element_done(m_newElement,m_newElementCopy,m_event,'paste');
           
           // If Failed, quickly exit
           if(!mRet)
           {
              break;
           }
           else
           {
              // Date: 2007-3-14
              // Because the roles of importNode function is to clone and set the clone parent to the
              // caller, the child of oOrigNode will not be removed. For this reason, here  we should 
              // remove the child of oOrigNode manually, otherwise the m_newElementCopy will be perm-
              // nent as the firstChild of oOrigNode.
              oOrigNode.removeChild(m_newElementCopy);
           }
      }
      
      f_repaint(event);                           
      
  }catch(e){
     alert('Exception from Edit.js fClipboardGet() '+e);
  }
 }